;SETTLE.SC                                                                   --->
;
; The procedures used to fill an invoice
;
; (C) 1993 by Timothy J. Massey
;  All Rights Reserved
;
; Portions copied from the book "Using Paradox 4 Special Edition"
;  by Walter R. Bruce III, published by Que.
;
;
; This script file fills INVOICE.LIB with the following procedures:
;
; User procedures called:
;
LibName = ScriptDir + "SETTLE" ; All procedures in this script are stored
				;  in INVOICE.LIB


;**********************************************************************;
;                                Settlement()                          ;
;                                                                      ;
;                                                                      ;
;**********************************************************************;
PROC Settlement()

Requery=True
WHILE Requery=True
   SettleSales()
ENDWHILE

ENDPROC

WRITELIB libname Settlement      ; Writes procedure to UTIL.SC
RELEASE PROCS Settlement         ;  and releases it from memory


;**********************************************************************;
;                               SettleSales()                          ;
;                                                                      ;
;                                                                      ;
;**********************************************************************;
PROC SettleSales()

ChangeSaleType=False
Requery=False

IF NOT Requery=True THEN

   Salesman=GetSalesID()
   IF Salesman=False THEN
      RETURN 0
   ENDIF

   IF Salesman=True THEN
      Salesman=".."                        ; DOESN'T WORK !!!!!!!!!!!!
   ENDIF
ENDIF

Term=ConfirmBox("Is this the end of the term?","","")
IF Term=True THEN
   PrintTax=ConfirmBox("Do you want a tax sheet?","","")
ELSE
   PrintTax=False
ENDIF

Query    ; QUERIES\SETDATA

 Invoice |   Invoice#    |  Cust#   | Subtotal |  Tax   | Total  | 
	 | Check _InvNum | _CustNum | Check    | Check  | Check  | 

 Invoice |  Date  |     Type      | Salesman Code   | GrossProfit | 
	 | Check  | Check NOT POA | Check ~Salesman | Check       | 

 Invoice |  Settled?   | Shared Discount | Salesman Discount | Franchise Discount | 
	 | Check NOT Y | Check           | Check             | Check              | 

 Invoice | CommLevel | PartComm1 | PartComm2 | PartComm3 | PartComm4 | 
	 | Check     | Check     | Check     | Check     | Check     | 

 Invoice | PartComm5 | 
	 | Check     | 

 Customer |  Cust#   | Customer Name | 
	  | _CustNum | Check         | 

 Customer |           | 

Endquery
DO_IT!

IF ISEMPTY("Answer") THEN
   MESSAGE "There are no invoices to process"
   DELETE "Answer"
   RETURN 1
ENDIF

InvCnt=CCOUNT("Answer","Invoice#")
CSubtotal=CSUM("Answer", "Subtotal")
CTax=CSUM("Answer", "Tax")
CGrossProfit=CSUM("Answer","GrossProfit")
CGrossProfit=(CGrossProfit/CSubtotal)*100
CShared=CSUM("Answer","Shared Discount")
CSales=CSUM("Answer","Salesman Discount")
CFranchise=CSUM("Answer","Franchise Discount")

Query   ;   QUERIES\SETDATA2

 Invoice |   Invoice#    |  Cust#   | Subtotal |  Tax   | Total  | 
	 | Check _InvNum | _CustNum | Check    | Check  | Check  | 

 Invoice |  Date  |  Type  | Salesman Code   | GrossProfit |  Settled?   | 
	 | Check  | Check  | Check ~Salesman | Check       | Check NOT Y | 

 Invoice | Shared Discount | Salesman Discount | Franchise Discount | 
	 | Check           | Check             | Check              | 

 Invoice | CommLevel | PartComm1 | PartComm2 | PartComm3 | PartComm4 | 
	 | Check     | Check     | Check     | Check     | Check     | 

 Invoice | PartComm5 | 
	 | Check     | 

 Customer |     Cust#      | Customer Name | 
	  | Check _CustNum | Check         | 

 Customer | 
	  | 

Endquery

DO_IT!

IF ISEMPTY("Answer") THEN
   MESSAGE "There are no invoices to process"
   DELETE "Answer"
   RETURN 1
ENDIF

CTotal=CSUM("Answer","Total")
POASales=0

COPY "Answer" "Totinv"
COPYFORM TableDir + "DummySet" 1 "Totinv" 1
COPYFORM TableDir + "DummySet" 2 "Totinv" 2
COPYREPORT TableDir + "DummySet" 1 "Totinv" "1"

VIEW "Config"
WINDOW HANDLE CURRENT TO TwhndConfig
FranNum=[Franchise#]
WINDOW CLOSE

Query   ;   QUERIES\RECEIPT

 Invoice |   Total    | Type | Salesman Code | Settled? |
	 | CheckPlus  | POA  | ~Salesman     |  NOT Y   |

 Invoice | 
	 | 

Endquery
DO_IT!
Receipts=IIF(ISEMPTY("Answer"),0,CSUM("Answer", "Total"))
POASales=Receipts

Query   ;   QUERIES\DATE

 Invoice |          Date          | Salesman Code | 
	 | Check COUNT UNIQUE >=1 | ~Salesman     | 

 Invoice | Settled? | 
	 | NOT Y    | 

Endquery
DO_IT!

DateCnt=NRECORDS("Answer")
SalesCnt=CSubtotal

WINDOW HANDLE CURRENT TO TwhndAnswer
WINDOW SELECT TwhndAnswer
WINDOW CLOSE

Query  ;  QUERIES\SETDATE

 Invoice | Invoice# |      Date       | Salesman Code | 
 set     | _Inv     | _Date           | ~Salesman     | 
         |          | Check max _Date |               | 

 Invoice | Settled? | 
         | NOT Y    | 
         |          | 

Endquery
DO_IT!
WINDOW HANDLE CURRENT TO TwhndAnswer
MOVETO[Answer->Date]
LastDate=[]
WINDOW SELECT TwhndAnswer
WINDOW CLOSE

VIEW "Totinv"
WINDOW HANDLE CURRENT TO TwhndTotInv
WINDOW MOVE TwhndTotInv TO 1000,0

VIEW TableDir + "Config"
WINDOW HANDLE CURRENT TO TwhndConfig
WINDOW MOVE TwhndConfig TO 1000,0

MOVETO[TotInv->]
CashSales=0
SharedDiscount=0
SalesDiscount=0
FranchiseDiscount=0
ChargeSales=0
Comm0=0
Comm1=0
Comm2=0
Comm3=0
Comm4=0
CommA=0
CommB=0
CommC=0
CommD=0
CommE=0

SCAN

   UniqueCommLevel=[PartComm1]+[PartComm2]+[PartComm3]+
       [PartComm4]+[PartComm5]

   CommA=CommA+[PartComm1]
   CommB=CommB+[PartComm2]
   CommC=CommC+[PartComm3]
   CommD=CommD+[PartComm4]
   CommE=CommE+[PartComm5]

   SWITCH
      CASE [Type]="CASH" :
	 CashSales=CashSales+ROUND([Total],2)
      
      CASE [Type]="CHARGE" :
	 ChargeSales=ChargeSales+ROUND([Total],2)
   ENDSWITCH
   SWITCH
      CASE [CommLevel]="0" :
	 Comm0=Comm0+[Subtotal]-UniqueCommLevel
      CASE [CommLevel]="1" :
	 Comm1=Comm1+[Subtotal]-UniqueCommLevel
      CASE [CommLevel]="2" :
	 Comm2=Comm2+[Subtotal]-UniqueCommLevel
      CASE [CommLevel]="3" :
	 Comm3=Comm3+[Subtotal]-UniqueCommLevel
      CASE [CommLevel]="4" :
	 Comm4=Comm4+[Subtotal]-UniqueCommLevel
   ENDSWITCH

   SharedDiscount=SharedDiscount+[Shared Discount]
   SalesDiscount=SalesDiscount+[Salesman Discount]
   FranchiseDiscount=FranchiseDiscount+[Franchise Discount]
ENDSCAN
Comm0=Comm0-POASales
TotalSales=CashSales+Receipts+CTax
PrcntComm0=[Config->CommLevel 0]
PrcntComm1=[Config->CommLevel 1]
PrcntComm2=[Config->CommLevel 2]
PrcntComm3=[Config->CommLevel 3]
PrcntComm4=[Config->CommLevel 4]
PrcntCommA=[Config->CommLevel 5]
PrcntCommB=[Config->CommLevel 6]
PrcntCommC=[Config->CommLevel 7]
PrcntCommD=[Config->CommLevel 8]
PrcntCommE=[Config->CommLevel 9]

PayComm0=Comm0*[Config->CommLevel 0]
PayComm1=Comm1*[Config->CommLevel 1]
PayComm2=Comm2*[Config->CommLevel 2]
PayComm3=Comm3*[Config->CommLevel 3]
PayComm4=Comm4*[Config->CommLevel 4]
PayCommA=CommA*[Config->CommLevel 5]
PayCommB=CommB*[Config->CommLevel 6]
PayCommC=CommC*[Config->CommLevel 7]
PayCommD=CommD*[Config->CommLevel 8]
PayCommE=CommE*[Config->CommLevel 9]

TotalPayComm=PayComm0+PayComm1+PayComm2+PayComm3+PayComm4+
	     PayCommA+PayCommB+PayCommC+PayCommD+PayCommE
SharedCommDeduct=SharedDiscount*[Config->CommLevel 0]
NetComm=TotalPayComm-SalesDiscount-SharedCommDeduct
;UnpaidCharges=(ChargeSales-Receipts)*PrcntComm0
UnpaidCharges=(ChargeSales)*PrcntComm0
TotalComm=NetComm-UnpaidCharges

CashReceived=CashSales+Receipts
TotalCharge=ChargeSales
ChargePayments=Receipts
TotalMightySales=CashReceived+TotalCharge-ChargePayments
TotalTax=CTax

FinalOrTemp=IIF(Term=True,"Final","Temporary")+" Report"

CLEARALL

VIEW TableDir + "Invoice"
WINDOW HANDLE CURRENT TO TwhndInvoice
WINDOW MOVE TwhndInvoice TO 1000,0

VIEW TableDir + "Lineitem"
WINDOW HANDLE CURRENT TO TwhndLineitem
WINDOW MOVE TwhndLineitem TO 1000,0

VIEW "TotInv"
WINDOW HANDLE CURRENT TO TwhndTotInv
WINDOW MOVE TwhndTotInv TO 1000,0

PICKFORM "1"
WINDOW HANDLE CURRENT TO FwhndTotInv
MaxWindow(FwhndTotInv)
FormPage=1

InvoiceNum=[Invoice#]

SHOWPULLDOWN
   ""          : "About application"                   : "AboutBox",
   "Print"      : "Print invoice"                       : "PrintSettle",
   "Sale Type"  : "Allows user to change sales type"    : "ChangeSaleType",
   "Delete"     : "Allows user to delete invoice"       : "DeleteSettle",
   "Pa~g~e"     : "Toggles summary and detail information" : "Page",
   "Cancel"     : "Cancel the current invoice"          : "CancelMenu"
      SUBMENU
      "No"      : "Do not cancel the current invoice"   : "NoCancel",
      "Yes"     : "Cancel the current invoice"          : "Cancel"
      ENDSUBMENU
ENDMENU

COEDITKEY
IMAGERIGHTS READONLY

PromptString=IIF(Term=True,"THIS IS A FINAL SETTLEMENT SHEET!","")
PROMPT"  [F10] Menu      "+PromptString
HOME
WAIT WORKSPACE                  ; Allows user to wander on desktop
   PROC "SettleWaitProc"        ; PROC that handles user events
   TRIGGER "ARRIVEROW"
   MESSAGE "MENUSELECT"         ;  or a menu is chosen,
ENDWAIT                         ;  an event is passed to OrderWaitProc()

DO_IT!

SHOWPULLDOWN ENDMENU            ; Clear menu
PROMPT ""                       ; Clear prompt

CLEARALL
ECHO NORMAL
ECHO OFF

IF Requery=False THEN
   IF Term=True THEN
      Query   ;   QUERIES\SETTERM

       Invoice | Salesman Code |     Settled?      |
   	       | ~Salesman     | NOT Y, CHANGETO Y |

      Endquery
      DO_IT!
   ENDIF
ENDIF

CLEARALL
ECHO NORMAL
ECHO OFF

;IF ISTABLE("TotInv") THEN DELETE "TotInv" ENDIF
IF ISTABLE("Answer") THEN DELETE "Answer" ENDIF
IF ISTABLE("Changed") THEN DELETE "Changed" ENDIF


ENDPROC

WRITELIB libname SettleSales      ; Writes procedure to UTIL.SC
RELEASE PROCS SettleSales         ;  and releases it from memory


;***********************************************************************;
;                              SettleWaitProc()                         ;
; This procedure handles user interaction while viewing the settlement  ;
; form.                                                                 ;
;***********************************************************************;
PROC SettleWaitProc(EventType, EventRecord, CycleNumber)
SWITCH

   CASE EventType="ARRIVEROW" :
      InvoiceNum=[Invoice#]
   RETURN 0

   CASE EventRecord["TYPE"]="MESSAGE" :
   SWITCH
      CASE EventRecord["MenuTag"]="AboutBox" :
	 AboutBox()
      RETURN 1

      CASE EventRecord["MenuTag"]="PrintSettle" :

         IF ChangeSaleType=True THEN 
            Requery=True
         ELSE
   	    IF CheckPrinter() THEN
   	    MESSAGE "Printing Settlement..."
               DO_IT!
	       REPORT "TotInv" "1"
      	       IF PrintTax=True THEN TaxSheet(False) ENDIF
   	       MESSAGE ""
	       RETURN 2
	    ELSE
	       MESSAGE "Print job cancelled"
	       SLEEP 2000
	       MESSAGE ""
	       RETURN 1
	    ENDIF
            RETURN 0
         ENDIF

      CASE EventRecord["MenuTag"]="ChangeSaleType" :
         ChangeSaleType()
      RETURN 1

      CASE EventRecord["MenuTag"]="DeleteSettle" :
         DeleteSettle()
      RETURN 1

      CASE EventRecord["MenuTag"]="Page" :
         IF FormPage=1 THEN
            WINDOW SELECT TwhndTotInv
            PICKFORM "2"
            WINDOW HANDLE CURRENT TO FwhndTotInv
            MaxWindow(FwhndTotInv)
            FormPage=2
         ELSE
            WINDOW SELECT TwhndTotInv
            PICKFORM "1"
            WINDOW HANDLE CURRENT TO FwhndTotInv
            MaxWindow(FwhndTotInv)
            FormPage=1
         ENDIF
      RETURN 1

     CASE EventRecord["MenuTag"]="Cancel" :
	 Term=False
      RETURN 2
   ENDSWITCH
ENDSWITCH

ENDPROC

WRITELIB libname SettleWaitProc      ; Writes procedure to UTIL.SC
RELEASE PROCS SettleWaitProc         ;  and releases it from memory


;***********************************************************************;
;                              ChangeSaleType()                         ;
; This procedure handles user interaction while viewing the settlement  ;
; form.                                                                 ;
;***********************************************************************;
PROC ChangeSaleType()

ChangeSaleType=True

InvType=CashOrCharge()

RecNum=RECNO()
WINDOW SELECT TwhndInvoice

MOVETO [Invoice->Invoice#]
LOCATE InvoiceNum
IF RetVal<>False THEN
   IMAGERIGHTS
   [Type]=Invtype
ENDIF

WINDOW SELECT FwhndTotInv
MOVETO [TotInv->Invoice#]
LOCATE InvoiceNum
IF RetVal<>False THEN
   IMAGERIGHTS
   [Type]=Invtype
ENDIF

ECHO NORMAL
ECHO OFF
IMAGERIGHTS READONLY
WINDOW SELECT FwhndTotInv
MOVETO [TotInv->]
MOVETO RECORD RecNum

ENDPROC

WRITELIB libname ChangeSaleType      ; Writes procedure to UTIL.SC
RELEASE PROCS ChangeSaleType         ;  and releases it from memory


;***********************************************************************;
;                               DeleteSettle()                          ;
;***********************************************************************;
PROC DeleteSettle()

ChangeSaleType=True

InvoiceNum=[Invoice#]

IF ConfirmBox("Are you sure you want to delete #"+STRVAL(InvoiceNum)+"?", "", "")=FALSE THEN
   RETURN 1
ENDIF

RecNum=RECNO()

WINDOW SELECT TwhndInvoice

MOVETO [Invoice->Invoice#]
LOCATE InvoiceNum
IF RetVal<>False THEN
   IMAGERIGHTS
   DEL
ENDIF

WINDOW SELECT TwhndLineitem

MOVETO [Lineitem->Invoice#]
IMAGERIGHTS
WHILE TRUE
   LOCATE InvoiceNum
   IF RetVal=FALSE THEN
      QUITLOOP
   ENDIF
   DEL
ENDWHILE

WINDOW SELECT FwhndTotInv
MOVETO [TotInv->]
IMAGERIGHTS
MOVETO RECORD RecNum
DEL

ECHO NORMAL
ECHO OFF
IMAGERIGHTS READONLY

ENDPROC

WRITELIB libname DeleteSettle      ; Writes procedure to UTIL.SC
RELEASE PROCS DeleteSettle         ;  and releases it from memory


;***********************************************************************;
;                                GetSalesID()                           ;
; This procedure opens a dialog box with 3 controls: an ACCCEPT box to  ;
; enter an ID # int, an OK and a CANCEL buttons.                        ;
;***********************************************************************;
PROC GetSalesID()
   PRIVATE SalesID, ButtonVal    ; Local variable definiton

SalesID=""
SHOWDIALOG "Salesperson Code"
 PROC"GetSalesIDProc"
 @ 6,20
 HEIGHT 9 WIDTH 40
				; Create a dialog box at 6,20 that's 7X40 big

@ 1,3 ?? "Enter salesperson code:"    ; Write label in box

ACCEPT @ 1,27 WIDTH 6           ; Create an ACCEPT element
 "A3"                            ; Accept numeric
 LOOKUP TableDir + "Salesman"   ; Valcheck with Customer table
 PICTURE "[&[&[&]]]"
 TAG "AcceptTag"                ; Unused
 TO SalesID                      ; User's input put here

PUSHBUTTON @ 3,15 WIDTH 10      ; Place button
 "Options"                      ; Button label
 VALUE True                     ; Value of button when pressed
 TAG "Options"                  ; Unused
 TO SalesID                     ; Return user's button selection here

PUSHBUTTON @ 5,6 WIDTH 10       ; Place button
 "OK"                           ; Button label
 OK                             ; Action of button when pressed
 DEFAULT                        ; This is the default button
 VALUE True                     ; Value of button when pressed
 TAG "OKbutton"                 ; Unused
 TO ButtonVal                   ; Return user's button selection here

PUSHBUTTON @ 5,23 WIDTH 10      ; Place button
 "Cancel"                       ; Button label
 CANCEL                         ; Action of button when pressed
 VALUE False                    ; Value of button when pressed
 TAG "Cancelbutton"             ; Unused
 TO ButtonVal                   ; Return user's button selection here

ENDDIALOG                       ; End dialog box construction

IF RetVal=FALSE THEN RETURN FALSE
   ELSE RETURN SalesID
ENDIF
				; Return the number typed if exists, else
				;  return False

ENDPROC

WRITELIB libname GetSalesID      ; Writes procedure to UTIL.SC
RELEASE PROCS GetSalesID         ;  


;***********************************************************************;
;                                GetSalesID()                           ;
; This procedure opens a dialog box with 3 controls: an ACCCEPT box to  ;
; enter an ID # int, an OK and a CANCEL buttons.                        ;
;***********************************************************************;
PROC GetSalesIDProc(TriggerType, TagValue, EventValue, ElementValue)

SWITCH
   CASE TriggerType="UPDATE" AND TagValue="Options" :

      VIEW TableDir + "Salesman"
      WINDOW HANDLE CURRENT TO TwhndSalesman
      WINDOW MOVE TwhndSalesman TO 1000,0

      MOVETO[Salesman->Salesperson Code]
      HOME
      ARRAY SalesmanList[NRECORDS(TableDir + "Salesman")]
      ARRAY DummyList[NRECORDS(TableDir + "Salesman")]
      LoopCount=1

      SCAN
	 SalesmanList[LoopCount]=[]
	 DummyList[LoopCount]=" "
	 LoopCount=LoopCount+1
      ENDSCAN

      SHOWARRAY SalesmanList DummyList TO SalesID
      RESYNCDIALOG

   RETURN True

   OTHERWISE :

   RETURN True

ENDSWITCH

ENDPROC

WRITELIB LibName GetSalesIDProc                                         ; Adds the procedure to the current library,
RELEASE PROCS GetSalesIDProc                                            ;  and releases it from memory.


;***********************************************************************;
;                               MenuTaxSheet()                          ;
; This procedure sends a 1 to the TaxSheet() proc so that it displays   ;
; the form...                                                           ;
;***********************************************************************;
PROC MenuTaxSheet()

TaxSheet(True)

ENDPROC

WRITELIB LibName MenuTaxSheet                                           ; Adds the procedure to the current library,
RELEASE PROCS MenuTaxSheet                                              ;  and releases it from memory.


;***********************************************************************;
;                                 TaxSheet()                            ;
; This procedure prints a sheet that lists all taxes due in this period ;
; for each state.                                                       ;
;***********************************************************************;
PROC TaxSheet(DisplayFlag)

Query

 Invoice | Invoice# |  Cust#   |  Tax   | Settled? | 
	 | Check    | _CustNum | Check  | NOT Y    | 

 Invoice | 
	 | 

 Customer |  Cust#   | State  | 
	  | _CustNum | Check  | 

Endquery
DO_IT!
WINDOW HANDLE CURRENT TO TwhndAnswer

IF ISEMPTY("Answer") OR CSUM("Answer", "Tax")=0 THEN 
   WINDOW SELECT TwhndAnswer
   WINDOW CLOSE
   DELETE "Answer"
   MESSAGE "There are no taxes due"
   SLEEP 2000
   RETURN 1
ENDIF

DYNARRAY StateTax[]

MOVETO [Answer->Invoice#]
HOME
SCAN
   IF ISASSIGNED(StateTax[UPPER(STRVAL([State]))]) THEN 
      StateTax[UPPER(STRVAL([State]))]=StateTax[UPPER(STRVAL([State]))]+[Tax]
   ELSE
      StateTax[UPPER(STRVAL([State]))]=[Tax]
   ENDIF
ENDSCAN

COPY TableDir+"DummyTax" TableDir+"TaxData"
VIEW TableDir+"TaxData"
WINDOW HANDLE CURRENT TO TwhndTaxData
WINDOW MOVE TwhndTaxData TO 1000,0
MOVETO[Invoice#]

COEDITKEY
FOREACH ArrayName IN StateTax
   [State]=ArrayName
   [Tax]=StateTax[ArrayName]
   DOWN
ENDFOREACH

IF DisplayFlag=True THEN
   PICKFORM 1
   WINDOW HANDLE FORM TO FwhndTaxData
   MaxWindow(FwhndTaxData)
   IMAGERIGHTS READONLY
   GenericMenu()
   WAIT WORKSPACE
     PROC "GenericWaitProc"
     MESSAGE "MENUSELECT"               ;  or a menu is chosen,
   ENDWAIT
ELSE
   IF CheckPrinter() THEN
      PrintSelect=True
   ELSE
      PrintSelect=False
   ENDIF
ENDIF

DO_IT!
     

IF PrintSelect=True THEN
   MESSAGE "Printing Tax Sheet..."
   REPORT TableDir+"TaxData" "1"
   MESSAGE ""
ELSE
   MESSAGE "Print job cancelled"
   SLEEP 2000
ENDIF

SHOWPULLDOWN ENDMENU            ; Clear menu
PROMPT ""                       ; Clear prompt

IF ISASSIGNED(FwhndTaxData) THEN
   WINDOW SELECT FwhndTaxData
   WINDOW CLOSE
ENDIF

WINDOW SELECT TwhndAnswer
WINDOW CLOSE
WINDOW SELECT TwhndTaxData
WINDOW CLOSE
DELETE "Answer"
DELETE TableDir+"TaxData"

CLEARALL
ECHO NORMAL
ECHO OFF

ENDPROC

WRITELIB LibName TaxSheet      ; Writes procedure to UTIL.SC
RELEASE PROCS TaxSheet         ;  and releases it from memory


;***********************************************************************;
;                                UniqueDesc()                           ;
; This procedure prints out all unique part descriptions contained in   ;
; the Parts table.                                                      ;
;***********************************************************************;
PROC UniqueDesc()

Query

 Parts |     Desc.      | 
       | Check calc min | 

Endquery
DO_IT!

WINDOW HANDLE CURRENT TO TwhndAnswer
MOVETO [Desc.]
COEDITKEY

SCAN
   IF ISBLANK([Desc.]) THEN DEL ENDIF
ENDSCAN
DO_IT!

COPYFORM TableDir + "DummyUni" "1" "Answer" "1"
COPYREPORT TableDir + "DummyUni" "1" "Answer" "1"

IMAGERIGHTS READONLY
PICKFORM "1"
WINDOW HANDLE CURRENT TO FwhndAnswer
MaxWindow(FwhndAnswer)

MOVETO [Desc.]
HOME

SHOWPULLDOWN
   ""          : "About application"                   : "AboutBox",
   "Print"      : "Print invoice"                       : "PrintList",
   "Cancel"     : "Cancel the current invoice"          : "CancelMenu"
      SUBMENU
      "No"      : "Do not cancel the current invoice"   : "NoCancel",
      "Yes"     : "Cancel the current invoice"          : "Cancel"
      ENDSUBMENU
ENDMENU

PROMPT"  [F10] Menu"
WAIT WORKSPACE                  ; Allows user to wander on desktop
   PROC "GenericWaitProc"       ; PROC that handles user events
   MESSAGE "MENUSELECT"         ;  or a menu is chosen,
ENDWAIT                         ;  an event is passed to OrderWaitProc()

SHOWPULLDOWN ENDMENU            ; Clear menu
PROMPT ""                       ; Clear prompt

IF PrintSelect=True THEN
   MESSAGE "Printing..."
   REPORT "Answer" "1"
   MESSAGE ""
ENDIF

IF ISTABLE("Answer") THEN DELETE "Answer" ENDIF

CLEARALL
ECHO NORMAL
ECHO OFF

ENDPROC

WRITELIB LibName UniqueDesc      ; Writes procedure to UTIL.SC
RELEASE PROCS UniqueDesc         ;  and releases it from memory


;***********************************************************************;
;                                 PartsList()                           ;
; This procedure prints out a list of all parts in the Parts table.     ;
;                                                                       ;
;***********************************************************************;
PROC PartsList()

IF ConfirmBox("This will delete the previous inventory. Continue?","","")=FALSE THEN
   RETURN FALSE
ENDIF

IF ISTABLE(TableDir+"PartSort") THEN DELETE TableDir+"PartSort" ENDIF
IF ISTABLE(TableDir+"PartQty") THEN DELETE TableDir+"PartQty" ENDIF

Query

 Parts | Part#  | Desc.  | Maker  | Price  |  Cost  | 
       | Check  | Check  | Check  | Check  | Check  | 

Endquery
DO_IT!

WINDOW HANDLE CURRENT TO TwhndAnswer

SORT "Answer" ON "Desc." "Part#"

COPY "Answer" TableDir+"PartSort"

COPYREPORT TableDir + "Dummyinv" "1" "Answer" "1"
COPYFORM TableDir + "Dummyinv" "1" "Answer" "1"

COEDITKEY
PICKFORM 1
WINDOW HANDLE FORM TO FwhndAnswer
MaxWindow(FwhndAnswer)

IMAGERIGHTS READONLY
HOME

GenericMenu()

WAIT WORKSPACE
  PROC "GenericWaitProc"
  MESSAGE "MENUSELECT"          ;  or a menu is chosen,
ENDWAIT

DO_IT!

IF PrintSelect=True THEN
   MESSAGE "Printing Parts List..."
   REPORT TableDir+"Answer" "1"
   MESSAGE ""
ELSE
   MESSAGE "Print job cancelled"
   SLEEP 2000
ENDIF

SHOWPULLDOWN ENDMENU            ; Clear menu
PROMPT ""                       ; Clear prompt

CLEARALL
ECHO NORMAL
ECHO OFF

IF ISTABLE("Answer") THEN DELETE "Answer" ENDIF

ENDPROC

WRITELIB LibName PartsList      ; Writes procedure to UTIL.SC
RELEASE PROCS PartsList         ;  and releases it from memory


;***********************************************************************;
;                                 EnterQty()                            ;
; This procedure allows the user to enter the quantity of parts on hand ;
; and prints out the value of the inventory.                            ;
;***********************************************************************;
PROC EnterQty()

IF NOT ISTABLE(TableDir+"PartSort") THEN
   MESSAGE "You must create a parts list first"
   RETURN 1
ENDIF

IF NOT ISTABLE(TableDir + "PartQty") THEN
   COPY TableDir + "DummyQty" TableDir + "PartQty"
ENDIF

VIEW TableDir + "PartQty"
WINDOW HANDLE CURRENT TO TwhndPartQty
WINDOW MOVE TwhndPartQty TO 1000,0

COEDIT TableDir + "PartSort"
WINDOW HANDLE CURRENT TO TwhndPartSort
WINDOW MOVE TwhndPartSort TO 1000,0

MOVETO[PartQty->Part#]
END
LastPartDone=[Part#]
PartQuantity=IIF(ISBLANK([Quantity]),0,[Quantity])

MOVETO [PartSort->Part#]
HOME
IF NOT ISBLANK(LastPartDone) THEN LOCATE LastPartDone DOWN ENDIF

SCAN
   RecNum=RECNO()
   IF ISBLANK([Part#]) THEN QUITLOOP ENDIF
   IF SEARCH(CHR(255),[Part#])=1 THEN LOOP ENDIF
   IF [Price]=0 THEN LOOP ENDIF

   PartNum=[Part#]
   PartDesc=[Desc.]
   PartMaker=[Maker]
   PartCost=[Cost]

   PartQuantity=InvEnterDlg(PartNum)
   IF PartQuantity=FALSE THEN
      DO_IT!
      CLEARALL
      RETURN 1
   ENDIF

   MOVETO[PartQty->Part#]
   END
   IF NOT ISBLANK([]) THEN
      DOWN
   ENDIF
   [Part#]=PartNum
   [Desc.]=PartDesc
   [Maker]=PartMaker
   [Cost]=PartCost
   [Quantity]=PartQuantity
   [Line Total]=PartQuantity*PartCost
   
   MOVETO [PartSort->]
   MOVETO RECORD RecNum
   [Price]=0
ENDSCAN
MOVETO[PartSort->Part#]
IF ISBLANK([]) THEN DEL ENDIF
DO_IT!

TotalQuantity=CSUM(TableDir+"PartQty", "Quantity")
TotalValue=CSUM(TableDir+"PartQty", "Line Total")

MOVETO[PartQty->Desc.]
COEDITKEY
PICKFORM 1
WINDOW HANDLE FORM TO FwhndPartQty
MaxWindow(FwhndPartQty)

IMAGERIGHTS READONLY

GenericMenu()

WAIT WORKSPACE
  PROC "GenericWaitProc"
  MESSAGE "MENUSELECT"          ;  or a menu is chosen,
ENDWAIT

DO_IT!

IF PrintSelect=True THEN
   MESSAGE "Printing Inventory List..."
   REPORT TableDir+"PartQty" "1"
   MESSAGE ""
ELSE
   MESSAGE "Print job cancelled"
   SLEEP 2000
ENDIF

SHOWPULLDOWN ENDMENU            ; Clear menu
PROMPT ""                       ; Clear prompt

CLEARALL
ECHO NORMAL
ECHO OFF

ENDPROC

WRITELIB LibName EnterQty                                               ; Adds the procedure to the current library,
RELEASE PROCS EnterQty                                                  ;  and releases it from memory.


;***********************************************************************;
;                               InvEnterDlg()                           ;
;***********************************************************************;
PROC InvEnterDlg(PartNum)
 PRIVATE PartNum

   SHOWDIALOG "Quantity"
    @6,20
    HEIGHT 7 WIDTH 40

      @1,3 ?? "Qty for #"+PartNum

      ACCEPT
	@1,23 WIDTH 14
	"N"
	REQUIRED
	MIN 0
	TAG "Qty"
      TO PartQuantity
  
      PUSHBUTTON @3,7 WIDTH 10
       "OK"
       OK
       DEFAULT
       VALUE TRUE
       TAG "OKButton"
      TO CButtonVal

      PUSHBUTTON @3,23 WIDTH 10
       "Cancel"
       CANCEL
       VALUE FALSE
       TAG "EndButton"
      TO CButtonVal

   ENDDIALOG

   IF RetVal=FALSE THEN
      RETURN FALSE
   ENDIF

RETURN PartQuantity

ENDPROC

WRITELIB LibName InvEnterDlg      ; Writes procedure to UTIL.SC
RELEASE PROCS InvEnterDlg         ;  and releases it from memory


;***********************************************************************;
;                            TotalGrossProfit()                         ;
;***********************************************************************;
PROC TotalGrossProfit()

SHOWDIALOG "Gross Profit"
 @7,20 HEIGHT 9 WIDTH 40

@1,2 ?? "Price List:"
ACCEPT
 @1,14 WIDTH 5
 "A1"
 PICTURE "[&]"
 TO PriceList

@3,2 ?? "Part Dept:"
ACCEPT
 @3,13 WIDTH 24
 "A20"
 PICTURE "*20{[!]}"
 TO PartDesc

PUSHBUTTON @5,7 WIDTH 10
 "OK"
 OK
 DEFAULT
 VALUE TRUE
 TAG "OKButton"
 TO ButtonVal

PUSHBUTTON @5,23 WIDTH 10
 "Cancel"
 CANCEL
 VALUE FALSE
 TAG "CancelButton"
 TO ButtonVal

ENDDIALOG

IF RetVal=FALSE THEN
   RETURN 1
ENDIF

PriceList=UPPER(PriceList)
IF PriceList="Z" THEN
   MESSAGE "The %GP of price list Z is always 0.00%."
   RETURN 1
ENDIF

IF (ASC(PriceList)<ASC("A")) AND (ASC(PriceList)>ASC("Y")) THEN
   MESSAGE "Price lists must be between A and Y."
   RETURN 1
ENDIF

{Ask} {parts} Right Check Example  "PartNum" Right Check Right 
Check Right Check Right Check 
MOVETO [Desc.]
TYPEIN STRVAL(PartDesc)+".."

IF PriceList>"A" THEN
   Menu {Ask} {auxparts} Right Example  "PartNum" 
   MOVETO FIELD "Price"+STRVAL(PriceList)
   Check
   TYPEIN  "as \"Price2\"" 
ENDIF

DO_IT!
WINDOW HANDLE CURRENT TO TwhndAnswer
WINDOW MOVE TwhndAnswer TO 1000,0

IF ISEMPTY("Answer") THEN
   MESSAGE "There are no parts with the description "+STRVAL(PartDesc+"..")
   RETURN 1
ENDIF

SORT "ANSWER" ON "Desc."

IF PriceList="A" THEN
   TotalGP=100-(CSUM("Answer", "Cost")/CSUM("Answer", "Price")*100)
ELSE
   TotPrice=0
   SCAN
      TotPrice=TotPrice+IIF(ISBLANK([Price2]),[Price],[Price2])
   ENDSCAN
   HOME
   TotalGP=100-(CSUM("Answer", "Cost")/TotPrice*100)
ENDIF

COPYREPORT "DummyGP"+IIF(PriceList="A","","2") "1" "Answer" "R"
COPYFORM "DummyGP"+IIF(PriceList="A","","2") "1" "Answer" "1"

MOVETO[Answer->]
COEDITKEY
PICKFORM 1
WINDOW HANDLE FORM TO FwhndAnswer
MaxWindow(FwhndAnswer)

IMAGERIGHTS READONLY

GenericMenu()

WAIT WORKSPACE
  PROC "GenericWaitProc"
  MESSAGE "MENUSELECT"          ;  or a menu is chosen,
ENDWAIT

DO_IT!

IF PrintSelect=True THEN
   SHOWPOPUP "Print Destination" CENTERED
      "Printer" : "Print report to printer" : "Printer",
      "File"    : "Print report to file"    : "File"
   ENDMENU TO PrintDest
   SWITCH
      CASE PrintDest="Printer" :
         MESSAGE "Printing GP Ananysis..."
         INSTANTREPORT
         MESSAGE ""
      CASE PrintDest="File" :
         MESSAGE "Saving Buying Pattern to \\GROSPRFT.RPT..."
            Menu {Report} {Output} {ANSWER} {R} {File} {\\GROSPRFT}
         MESSAGE ""
      OTHERWISE :
         MESSAGE "Print job cancelled"
         SLEEP 2000
   ENDSWITCH
ELSE
   MESSAGE "Print job cancelled"
   SLEEP 2000
ENDIF

SHOWPULLDOWN ENDMENU            ; Clear menu
PROMPT ""                       ; Clear prompt

CLEARALL
ECHO NORMAL
ECHO OFF

ENDPROC

WRITELIB LibName TotalGrossProfit      ; Writes procedure to UTIL.SC
RELEASE PROCS TotalGrossProfit         ;  and releases it from memory